#include	<stdlib.h>
#include	<stdio.h>
#include	<ctype.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<ctype.h>
#include	<string.h>

#ifdef	_MSC_VER
#include	<malloc.h>
#else
#include	<alloc.h>
#endif

//#include DEBFILE

//#include	"asm51.h"
#include	"y_tab.h"



#ifdef DEBUG
extern unsigned opcode;
extern unsigned cond;
extern unsigned xop;
extern unsigned yop;
extern unsigned left;
extern int immed;
#endif

extern yyparse ();
extern int yylval;			/* transfer token value to parser */

extern unsigned code_loc;
extern unsigned vcode_loc;
extern unsigned data_loc;

int pass;
int listflag = 0;
int crflag = 0;
int n_errors = 0;
char s[80];
char src_file_name[80];
int src_line = 0; /*1;*/
FILE *src_file;
FILE *out_file;
FILE *out_lstfile;
FILE *debfile;
char yystring[128];

typedef struct {
	int token;
	int val;
	char *s;
	} token_val;

typedef struct {
	  char *s;
	  unsigned val;
	} name;


#define MAX_SYMBOLS 1024
#define MAX_EQU 200
#define MAX_STRLEN 256


char mytmpstr[MAX_STRLEN];
char mytmpstr2[MAX_STRLEN];
char liststr[MAX_STRLEN];
char tmpch1[MAX_STRLEN], tmpch2[MAX_STRLEN];
int myptrb = 0;
int myptre = 0;

name symbols[MAX_SYMBOLS];
int	n_symbols = 0;

token_val reserved[] = 	{
	{ INCDEC, 0x04, "inc" },
	{ JP12, 0x11, "acall" },
	{ AS, 0x24, "add" }, { AS, 0x34, "addc" }, { LF, 0x52, "anl" },
	{ JP12, 0x01, "ajmp" },
	{ JP16, 0x12, "call" },
	{ BOP, 0xC2, "clr" }, { BOP, 0xB2, "cpl" }, { CJNE, 0xB4, "cjne" },
	{ B1A, 0xD4, "da" }, { INCDEC, 0x14, "dec" }, { MD, 0x84, "div" },
	{ DJNZ, 0xD5, "djnz" },
	{ JPB, 0x20, "jb" }, { JPB, 0x10, "jbc" }, { JPB, 0x30, "jnb" },
	{ JP8, 0x40, "jc" }, { JMP, 0x73, "jmp" }, { JP8, 0x50, "jnc" },
	{ JP8, 0x60, "jz" }, { JP8, 0x70, "jnz" },
	{ JP16, 0x02, "ljmp" }, { JP16, 0x12, "lcall" },
	{ MOV, 0x0, "mov" }, { MOVC, 0x83, "movc" }, { MOVX, 0xE0, "movx" },
	{ MD, 0xA4, "mul" }, { B1, 0x0, "nop" },
	{ LF, 0x42, "orl" },
	{ PP, 0xD0, "pop" }, { PP, 0xC0, "push" },
	{ B1, 0x22, "ret" }, { B1, 0x32, "reti" }, { B1A, 0x23, "rl" },
	{ B1A, 0x33, "rlc" }, { B1A, 0x03, "rr" }, { B1A, 0x13, "rrc" },
	{ BOP, 0xD2, "setb" },
	{ JP8, 0x80, "sjmp" }, { AS, 0x94, "subb" }, { B1A, 0xC4, "swap" },
	{ XCH, 0xC5, "xch" }, { XCHD, 0xD6, "xchd" }, { LF, 0x62, "xrl" },
/*
// REGISTER
*/
	{ A, 0x0, "a" }, { AB, 0x0, "ab" }, { C, 0x0, "c" },
	{ R01, 0x0, "r0" }, { R01, 0x1, "r1" }, { R27, 0x2, "r2" },
	{ R27, 0x3, "r3" }, { R27, 0x4, "r4" }, { R27, 0x5, "r5" },
	{ R27, 0x6, "r6" }, { R27, 0x7, "r7" },

	{ NR, 0xE0, "acc" }, { NR, 0xF0, "b" }, { NR, 0xD0, "psw" },
	{ NR, 0x81, "sp" }, { NR, 0x82, "dpl" }, { NR, 0x83, "dph" },
	{ DPTR, 0x83, "dptr" }, { PC, 0x0, "pc" },
	{ NR, 0x80, "p0" }, { NR, 0x90, "p1" },
	{ NR, 0xA0, "p2" }, { NR, 0xB0, "p3" },
	{ NR, 0xB8, "ip" },	{ NR, 0xA8, "ie" }, { NR, 0x89, "tmod" },
	{ NR, 0x88, "tcon" }, { NR, 0x8C, "th0" }, { NR, 0x8A, "tl0" },
	{ NR, 0x8D, "th1" }, { NR, 0x8B, "tl1" }, { NR, 0x98, "scon" },
	{ NR, 0x99, "sbuf" }, { NR, 0x87, "pcon" },
/*
// Named Bits
*/
	{ NB, 0xD7, "cy" }, { NB, 0xD6, "ac" }, { NB, 0xD5, "f0" },
	{ NB, 0xD4, "rs1" }, { NB, 0xD3, "rs0" }, { NB, 0xD2, "ov" },
	{ NB, 0xD0, "p" },

	{ NB, 0xB7, "rd" }, { NB, 0xB6, "wr" }, { NB, 0xB5, "t1" },
	{ NB, 0xB4, "t0" }, { NB, 0xB3, "int1" }, { NB, 0xB2, "int0" },
	{ NB, 0xB1, "txd" }, { NB, 0xB0, "rxd" },

	{ NB, 0x8F, "tf1" }, { NB, 0x8E, "tr1" }, { NB, 0x8D, "tf0" },
	{ NB, 0x8C, "tr0" }, { NB, 0x8B, "ie1" }, { NB, 0x8A, "it1" },
	{ NB, 0x89, "ie0" }, { NB, 0x88, "it0" },

	{ NB, 0x9F, "sm0" }, { NB, 0x9E, "sm1" }, { NB, 0x9D, "sm2" },
	{ NB, 0x9C, "ren" }, { NB, 0x9B, "tb8" }, { NB, 0x9A, "rb8" },
	{ NB, 0x99, "ti" }, { NB, 0x98, "ri" },

	{ NB, 0xAF, "ea" }, { NB, 0xAC, "es" }, { NB, 0xAB, "et1" },
	{ NB, 0xAA, "ex1" }, { NB, 0xA9, "et0" }, { NB, 0xA8, "ex0" },

	{ NB, 0xBC, "ps" }, { NB, 0xBB, "pt1" }, { NB, 0xBA, "px1" },
	{ NB, 0xB9, "pt0" }, { NB, 0xB8, "px0" },
/*
// Command
*/
	{ DB, 0x0, "db" }, { DW, 0x0, "dw" },
	{ DATA, 0x0, "data" }, { DS, 0x0, "ds" },
	{ ORG, 0x0, "org" }, { END, 0x0, "end" },
	{ WIDTH, 0x0, "width" },
	{ HB, 0x0, "hb" }, { LB, 0x0, "lb" },
	{ SHIFTL, 0x0, "<<" }, { SHIFTR, 0x0, ">>" }
	};

token_val directives[] = {
	{ INCLUDE, 0, "include" }};

void yyerror ( char *message )
{
	if(crflag == 0)
		printf("\n");
	crflag = 1;
	printf ( "%s line %d : %s\n", src_file_name, src_line, message );
	printf ("%s", mytmpstr );
	n_errors++;
}

extern int yydebug;
int change_src_file ( char* );

main ( int argc, char* argv[] )
{
int i;
	yydebug = 1;
	yydebug = 0;

	liststr[0] = 0;

	if ((argc < 2) || (argc > 3))
		{
		printf ( "usage: asm51m filename [l]\n" );
		return 1;
		}
	if(argc == 3)
		{
		if(argv[2][0] == 'l')
			{
			listflag = 1;
			strcpy ( s, argv[1] );
			if ( strchr ( s, '.' ) )
				*strchr ( s, '.' ) = 0;
			strcat ( s, ".lst" );
			if ( ( out_lstfile = fopen ( s, "wt" ) ) == NULL )
				{
				printf ( "can't open listing file %s\n", s );
				return ( 1 );
				}
			}
		else
			printf ( "usage: asm51m filename [l]\n" );
		}
	strcpy ( s, argv[1] );
	if ( !strchr ( s, '.' ) )
		strcat ( s, ".a51" );
	strcpy ( src_file_name, s );
	if ( ( src_file = fopen ( src_file_name, "rt" ) ) == NULL )
		{
		printf ( "can't open file %s\n", src_file_name );
		return ( 1 );
		}
	*strchr ( s, '.' ) = 0;
	strcat ( s, ".bin" );
	if ( ( out_file = fopen ( s, "wb" ) ) == NULL )
		{
		printf ( "can't open file %s\n", s );
		return ( 1 );
		}
	printf ( " +--------------------------------+\n" );
	printf ( " |     51XX Cross-assembler       |\n" );
	printf ( " |         Version 0.23           |\n" );
	printf ( " |   Copyright BIOLA Ltd. 1996    |\n" );
	printf ( " +--------------------------------+\n" );
	printf ( "   Last modifications - 98.05.03\n");
	printf ( "Pass 1\n" );
	vcode_loc = 0;
	code_loc = 0;
	data_loc = 0;
	pass = 1;
	crflag = 1;
	yyparse ();
	if ( n_errors == 0 )
		{
		if(crflag == 0)
			printf("\n");
		printf ( "Pass 2\n" );
		fseek ( src_file, 0L, SEEK_SET );
		vcode_loc = 0;
		code_loc = 0;
		data_loc = 0;
		src_line = 0; /*1;*/
		pass = 2;
		yyparse ();

#ifdef DEBFILE
		debfile = fopen("debbb", "wt");
		for(i=0; i<n_symbols; i++)
			fprintf(debfile, "%s = 0x%04X\n", symbols[i].s, symbols[i].val);
		fclose(debfile);
#endif
		}
	else
		printf ( "\nerrors detected in pass 1 - no pass 2\n" );
	fclose ( out_file );
	fclose ( src_file );
	if(listflag)
		fclose ( out_lstfile );
	printf ("\n%d errors\nlast code location 0x%04X\nlast data location 0x%04X\n\n",
		 n_errors, code_loc-1, data_loc-1 );
	return n_errors;
}

typedef struct src_file_tag {
	FILE	*file;
	int		line;
	char	*name;
	struct src_file_tag	*prev;
	} src_file_info;

int change_src_file ( char *fname )		// fname - name of file to open or
										// NULL to pop previous file
										// return s 0 on success, -1 on failure 
{
	static src_file_info *p = NULL;
	src_file_info	*tmp;
	FILE			*tmp_file;
	char err[80];

	if ( fname )
		{
		tmp_file = src_file;
		if ( ( tmp = (src_file_info *)malloc ( sizeof ( src_file_info ) ) ) == NULL ||
		( tmp->name = (unsigned char *)malloc ( strlen ( src_file_name ) + 1 ) ) == NULL )
			{
			printf ( "change_src_file : memory allocation failed\n" );
			return -1;
			}
		if ( ( src_file = fopen ( fname, "rt" ) ) == NULL )
			{
			strcpy ( err, "can't open file " );
			yyerror ( strcat ( err, fname ) );
			return -1;
			}
		tmp->prev = p;
		tmp->file = tmp_file;
		strcpy ( tmp->name, src_file_name );
		tmp->line = src_line;

		p = tmp;
		strcpy ( src_file_name, fname );
		src_line = 0; /*1;*/
		return 0;
		}
	else
		{
		if ( p == NULL )
			return -1;
		fclose ( src_file );
		src_file = p->file;
		strcpy ( src_file_name, p->name );
		src_line = p->line;
		tmp = p->prev;
		free ( p->name );
		free ( p );
		p = tmp;
		return 0;
		}
}

#define LEFTLIMIT 40

void emit ( unsigned char code )
{

/* //Comented ++++++ progress out
	if ((pass == 1) && (vcode_loc % 10 == 0) && (vcode_loc > 0))
		{
		printf("+");
		if(vcode_loc % 500 == 0)
			{
			printf("  %d\n", vcode_loc);
			crflag = 1;
			}
		else
			crflag = 0;
		}
*/

	if ( pass == 2 )
		{
		fwrite( &code, 1, 1, out_file );
		if(listflag)
			{
			if(liststr[0] == 0)
				sprintf(liststr, "%04X ", vcode_loc);
			sprintf(tmpch1, "%02X ", code);
			if(strlen(tmpch1) + strlen(liststr) < MAX_STRLEN)
				{
				strcat(liststr, tmpch1);
				if(strlen(liststr) > LEFTLIMIT - 1)
					{
					fprintf(out_lstfile, "%s\n", liststr);
					liststr[0]=0;
                    }
                }
			else
				{
				printf("List str overflow\n");
				}
			}
		/*fprintf ( out_file, "%02X\n", code );*/
/* //Comented ******* progress out
		if((vcode_loc % 10 == 0) && (vcode_loc > 0))
			{
			printf("*");
			if(vcode_loc % 500 == 0)
				{
				printf("  %d\n", vcode_loc);
				crflag = 1;
				}
			else
				crflag = 0;
			}
*/
		}
	vcode_loc++;
}

void listout(void)
{
int i, tmplen;

if((listflag == 0) || (pass == 1))
	return;

//sprintf(tmpch1, "%04X ", c_addr);
//strcat(tmpch1, liststr);

tmplen = strlen(liststr);
if((tmplen>0) && (liststr[tmplen-1] == '\n'))
	{
	liststr[tmplen-1] = 0;
	tmplen--;
	}
//	strchr ( , '.' )
for(i=tmplen; i<LEFTLIMIT; i++)
	liststr[i] = ' ';
if(i == LEFTLIMIT)
	liststr[i] = 0;

if(strlen(liststr) + strlen(mytmpstr) < MAX_STRLEN)
	{
	strcat(liststr, mytmpstr);
	fprintf(out_lstfile, "%s", liststr);
	liststr[0]=0;
	}
else
	{
	printf("List str overflow\n");
	}
}

int is_reserved ( char *s )
{
	int max = sizeof ( reserved ) / sizeof ( token_val );
	int i;
	char tmps[256];
	strcpy(tmps, s);
	for(i=strlen(tmps); i>0; i--)
		tmps[i-1] = tolower(tmps[i-1]);
	for ( i = 0; i < max; i++ )
		if ( strcmp ( tmps, reserved[i].s ) == 0 )
			return i;
	return -1;
}

int is_directive ( char *s )
{
	int max = sizeof ( directives ) / sizeof ( token_val );
	int i;

	for ( i = 0; i < max; i++ )
		if ( strcmp ( s, directives[i].s ) == 0 )
			return i;
	return -1;
}


int insert_label ( char *s, int val )
{
	int i;

	if(pass != 1)
		return -1;

if(s[0] != '_')
	for ( i = 0; i < n_symbols; i++ )
		if ( strcmp ( s, symbols[i].s ) == 0 )
			yyerror ( "symbol redefined" );

	if ( n_symbols == MAX_SYMBOLS )
		{
		printf ( "fatal: symbol table overflow - ASM51 aborted\n" );
		exit ( 1 );
		}
	symbols[n_symbols].s = (char*) malloc ( strlen ( s ) + 1 );
	strcpy ( symbols[n_symbols].s, s );
	symbols[n_symbols].val = val;
	return n_symbols++;
}

unsigned resolve_label ( char *s )
{
int i;
unsigned t_loc;
char flag=0;

if(pass != 2)
	return 0;

if(s[0] != '_')
	{
	for ( i = 0; i < n_symbols; i++ )
		if ( strcmp ( s, symbols[i].s ) == 0 )
			break;
	if ( i == n_symbols )
		{
		yyerror ( "unknown label" );
		return 0;
		}
	return symbols[i].val;
	}
else
	{
	if(s[3] != 0)
		yyerror ( "wrong local label" );
	if(s[2] == 'f' || s[2] == 'F')
		{
		s[2] = 0;
		t_loc = 0xffff;
		for ( i = 0; i < n_symbols; i++ )
			if ( strcmp ( s, symbols[i].s ) == 0 )
				if((symbols[i].val > code_loc) && (symbols[i].val <= t_loc))
					{
					t_loc = symbols[i].val;
					flag = 1;
					}
		if ( flag == 0 )
			yyerror ( "unknown loc_label_F" );
		return t_loc;
		}
	else if(s[2] == 'b' || s[2] == 'B')
		{
		s[2] = 0;
		t_loc = 0;
		for ( i = 0; i < n_symbols; i++ )
			if ( strcmp ( s, symbols[i].s ) == 0 )
				if((symbols[i].val <= code_loc) && (symbols[i].val >= t_loc))
					{
					t_loc = symbols[i].val;
					flag = 1;
					}
		if ( flag == 0 )
			yyerror ( "unknown loc_label_B" );
		return t_loc;
		}
	else
		yyerror ( "wrong referense on loc_label" );
	return 0;
	}
}

typedef struct {
	char *name;
	char *val;
	int lenval;
	} equ_val;
equ_val equ_mass[MAX_EQU];
int equ_count = 0;


int nextword(int fl, char dest[], char tmpmass[])
{
int j=0, k=0;
static int i;

if(fl == 0) /* Reset Ptr */
	{
	i=0;
	return 0;
    }

if(fl == 1) /* Next Word */
	{
	if((tmpmass[i] != ' ')&&(tmpmass[i] != '\t'))
		{
		while((tmpmass[i] != ' ')&&(tmpmass[i] != '\t')&&
			(tmpmass[i] != '\n')&&(i < myptre))
			if(isalnum(tmpmass[i]) || (tmpmass[i] == '_'))
				{
				k++;
				dest[j++] = tmpmass[i++];
				}
			else
				{
				if(k == 0)
					{
/*					printf("Ch1:%c",tmpmass[i]);
*/					dest[j++] = tmpmass[i++];
					break;
					}
				else
					{
/*					printf("Ch2:%c",tmpmass[i]);
*/					break;
					}
				}
		}
	else
		{
		dest[j++] = tmpmass[i++];
/*		dest[j++] = ' ';
		i++;
		while(((tmpmass[i] == ' ')||(tmpmass[i] == '\t')) && (i < myptre))
			i++;
*/		}
	} if (fl == 2) /* All Remainder */
	{
	while(((tmpmass[i] == ' ') || (tmpmass[i] == '\t')) && (i < myptre))
		i++;
	while((tmpmass[i] != '\n')&&(tmpmass[i] != ';')&&(i < myptre))
		{
		dest[j++] = tmpmass[i++];
		}
	while(((dest[j-1] == ' ') || (dest[j-1] == '\t')) && (j > 0))
		j--;
	}
dest[j] = 0;
return j;
}

void equreplace(char dststr[], char srcstr[])
{
int i, j, tmpptre, tmplen1;

	nextword(0, tmpch1, srcstr);
	dststr[0] = '\n';
	dststr[1] = 0;
	tmpptre = 0;
	while((tmplen1 = nextword(1, tmpch1, srcstr)) != 0)
		{
		if((tmplen1 == 1) && ((tmpch1[0] == ' ')||(tmpch1[0] == '\t')))
			{
			dststr[tmpptre++] = ' ';
			continue;
			}
		for(i=0; i< equ_count; i++)
			if(strcmp(equ_mass[i].name, tmpch1) == 0)
				break;
		if(i != equ_count)
			for(j=0; j<equ_mass[i].lenval; j++)
				dststr[tmpptre++] = equ_mass[i].val[j];
		else
			for(i=0; i<tmplen1; i++)
				dststr[tmpptre++] = tmpch1[i];
		}
dststr[tmpptre++] = '\n';
dststr[tmpptre] = 0;
myptre = tmpptre;
}

int equsearch(char srcstr[])
{
int tmplen1, tmplen2, tmplen3;

nextword(0, tmpch1, srcstr);
if((tmplen1 = nextword(1, tmpch1, srcstr)) == 0)
	;
else{
	 do	{
		tmplen2 = nextword(1, tmpch2, srcstr);
		} while((tmplen2==1) && ((tmpch2[0] == ' ') || (tmpch2[0] == '\t')));
	if(tmplen2 != 3)
		;
	else if((tolower(tmpch2[0]) != 'e') ||
		(tolower(tmpch2[1]) != 'q') ||
		(tolower(tmpch2[2]) != 'u'))
		;
	else if((nextword(1, tmpch2, srcstr)) != 1)
		;
	else if((tmpch2[0] != ' ') && (tmpch2[0] != '\t'))
		;
	else if((tmplen2 = nextword(2, tmpch2, srcstr)) == 0)
		{
		yyerror("EQU missing Err3");
		}
	else if(pass == 2)
		return 1;
	else if((equ_mass[equ_count].name = (unsigned char *)malloc (tmplen1 + 1)) == NULL )
		{
		yyerror( "mygetc 1 : memory allocation failed" );
		exit(1);
		}
	else {
		strcpy(equ_mass[equ_count].name, tmpch1);
		if((equ_mass[equ_count].val = (unsigned char *)malloc (tmplen2 + 1)) == NULL )
			{
			yyerror( "mygetc 2 : memory allocation failed" );
			exit(1);
			}
		equ_mass[equ_count].lenval = tmplen2;
		strcpy(equ_mass[equ_count].val, tmpch2);
		equ_count++;
		return 1;
		}
	}
return 0;
}

int myfgetc(FILE *tmp_fptr)
{
int ch;
int i, j;
/*
return(fgetc(tmp_fptr));
*/
nextstring:
if(myptrb == myptre)
	{
	src_line++;
	myptre = myptrb = 0;
	do{ ch = fgetc( tmp_fptr );
		if(myptre < MAX_STRLEN)
			{
			if((ch == EOF)&&(myptre == 0))
				return EOF;
			mytmpstr2[myptre++] = ch;
			}
		else
			{
			yyerror("Too long string");
			break;
			}
		} while((ch != '\n') && (ch != EOF));
	if(pass == 1)
		{
		equreplace(mytmpstr, mytmpstr2);
//		printf("EQU->%s", mytmpstr);
/*		memcpy(mytmpstr, mytmpstr2, 256 * 2);
*/
		if(equsearch(mytmpstr))
			{
			myptre = myptrb = 0;
			goto nextstring;
			}
		}
	else if(pass == 2)
		{
		if(equsearch(mytmpstr2))
			{
			myptre = myptrb = 0;
			goto nextstring;
			}
		equreplace(mytmpstr, mytmpstr2);
		}

	}
if(myptrb < myptre)
	{
	ch = mytmpstr[myptrb++];
	return ch;
	}
else {
	yyerror("Internal err1");
	return -1;
	}
}

int myungetc(int ch, FILE *tmp_fptr)
{
myptrb--;

if(myptrb < 0)
	{
	printf("Internal Err2\n");
	exit(1);
	}
mytmpstr[myptrb] = ch;
return ch;
}

int mydigconv( int c )
{
if(('0' <= c)&&(c <= '9'))
	return c - '0';
else if(('a' <= c)&&(c <= 'f'))
	return c - 'a' + 10;
else if(('A' <= c)&&(c <= 'F'))
	return c - 'A' + 10;
else return -1;
}

int mydigiscan(int c)
{
#define NUMBERLEN 10
char fornumber[NUMBERLEN];
int numberptr = 0;
int numberrad = 10;
int i, value;

numberrad = 10;
while( (i = mydigconv( c )) != -1)
	{
	if(numberptr < NUMBERLEN)
		{
		fornumber[numberptr++] = i;
		c = myfgetc ( src_file );
		}
	else yyerror("Number tmp string overflow");
	}
if(tolower( c ) == 'h')
	{
	numberrad = 0x10;
	if(numberptr > 4)
		yyerror("Hex number too great");
	}
else if(tolower( c ) == 'o')
	{
	numberrad = 8;
	if(numberptr > 6)
		yyerror("Octal number too great");
	}
else if((numberptr>1)&&(fornumber[numberptr-1] == 11))
	{
	numberptr--;
	numberrad = 2;
	if(numberptr > 8)
		yyerror("Bin number too great");
	myungetc ( c, src_file );
	}
else myungetc ( c, src_file );
if((numberptr > 5) && (numberrad == 10))
	yyerror("Decimal number too great");
value = 0;
for( i=0; i<numberptr; i++)
	{
	if(fornumber[i] >= numberrad)
		{
		yyerror("Convert number to rad Err");
		}
	value = value * numberrad + fornumber[i];
	}
return value;
}

int yylex ()
{
	char ident[80];
	char *p;
int c;
static int cflag=0;
	int	i;
	int file_op;
	static int prevtoken = 0;


	yylval = 0;
	for (;;)
		{
		c = myfgetc ( src_file );
		switch ( c )
			{
			case EOF :
			prevtoken = 0;
			if( !cflag )
				{
				cflag = 1;
				return EOL;
				}
			cflag = 0;
			if ( change_src_file ( NULL ) )
				return 0;
			continue;
			case ' ' :
			case '\t': continue;
			case '\n': /*src_line++;*/
				prevtoken = 0;
				return EOL; //continue;
			case '{' :
// process MultiLine comment { }
			prevtoken = 0;
			while ( ( c = myfgetc ( src_file ) ) != '}' )
				if ( c == EOF )
					{
					yyerror ( "end of file inside comment" );
					if ( change_src_file ( NULL ) )
						return 0;
					else
						continue;
					}
			continue;
			case '/' :
			if ( ( c = myfgetc ( src_file ) ) == '/' )
				{
// process C-style single line comment
				prevtoken = 0;
				while ( ( c = myfgetc ( src_file ) ) != '\n' )
					if ( c == EOF )
						{
						if ( change_src_file ( NULL ) )
							return 0;
						else
							continue;
						}
				return EOL;
				}
			else
				{
				myungetc ( c, src_file );
				return '/';
				}
			case ';' :
				{
// process ASM51 - style single line comment
				prevtoken = 0;
				while ( ( c = myfgetc ( src_file ) ) != '\n' )
					if ( c == EOF )
						{
						if ( change_src_file ( NULL ) )
							return 0;
						else
							continue;
						}
				return EOL;
				}

			case '0' :
			if ( ( c = myfgetc ( src_file ) ) == 'x' )
				{
				while ( isxdigit ( c = myfgetc ( src_file ) ) )
					yylval = yylval * 16 + ( isdigit ( c ) ? c - '0' :
					( isupper ( c ) ? c - 'A' + 10 : c - 'a' + 10 ) );
				myungetc ( c, src_file );
				return NUMBER;
				}
			else if ( isdigit ( c ) || (( 'A' <= c )&&( c <= 'F')) ||
					(( 'a' <= c )&&( c <= 'f')) || (c == 'h') || (c == 'H') ||
					(c == 'b') || (c == 'B') || (c == 'o') || (c == 'O'))
				{
				yylval = mydigiscan( c );
				return NUMBER;
				}
			else {
				myungetc ( c, src_file );
				yylval = 0;
				return NUMBER;
				}
			case '.':
			if(prevtoken)
				return c;
			for ( p = ident; isalnum ( c = myfgetc ( src_file ) ); p++ )
				*p = c;
			myungetc ( c, src_file );
			*p = 0;
			if ( ( i = is_directive ( ident ) ) == -1 )
				{
				yyerror ( "unknown directive" );
				return LABEL;
				}
			yylval = directives[i].val;
			return directives[i].token;
			case '"':
			for ( p = yystring; ( c = myfgetc ( src_file ) ) != '"'; p++ )
				*p = c;
			*p = 0;
			yylval = 0;
			return STRING;
			case 0x27: /* this - ' */
			for ( p = yystring; ( c = myfgetc ( src_file ) ) != 0x27; p++ )
				*p = c;
			*p = 0;
			yylval = 0;
			return STRING;
			default:
			if ( isdigit ( c ) )
				{
				yylval = mydigiscan( c );
				return NUMBER;
				}
			else if ( isalpha ( c ) || c == '_' )
				{
				int tch;
				p = ident;
				*p++ = c;
				while ( isalnum ( c = myfgetc ( src_file ) ) || c == '_' )
					*p++ = c;
//				if(pass == 1)
					while (c == ' ')
						c = myfgetc ( src_file );
				tch = c;
				myungetc ( c, src_file );
				*p = 0;
				if ( ( i = is_reserved ( ident ) ) == -1 )
					{
//					yylval = insert ( ident );
					if(pass == 2 || tch == ':')
						strcpy(yystring, ident);
					return LABEL;
					}
				prevtoken = 1;
				yylval = reserved[i].val;
				return reserved[i].token;
				}
			else return c;
		}
	}
}
